#include <kdialog.h>
#include <klocale.h>
#ifndef KMM_I18N
#define KMM_I18N
inline QString kmm_i18n(const char* msg, const char* ctx) { return i18n(ctx, msg); }
inline QString kmm_i18n(const char* msg) { return i18n(msg); }
#endif
/****************************************************************************
** Form implementation generated from reading ui file './ksettingsgpgdecl.ui'
**
** Created by User Interface Compiler
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "ksettingsgpgdecl.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qcheckbox.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <kcombobox.h>
#include <klineedit.h>
#include <keditlistbox.h>
#include <kled.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/*
 *  Constructs a KSettingsGpgDecl as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
KSettingsGpgDecl::KSettingsGpgDecl( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "KSettingsGpgDecl" );
    KSettingsGpgDeclLayout = new QVBoxLayout( this, 11, 6, "KSettingsGpgDeclLayout"); 

    kcfg_WriteDataEncrypted = new QCheckBox( this, "kcfg_WriteDataEncrypted" );
    KSettingsGpgDeclLayout->addWidget( kcfg_WriteDataEncrypted );

    m_idGroup = new QGroupBox( this, "m_idGroup" );
    m_idGroup->setEnabled( TRUE );
    m_idGroup->setColumnLayout(0, Qt::Vertical );
    m_idGroup->layout()->setSpacing( 6 );
    m_idGroup->layout()->setMargin( 11 );
    m_idGroupLayout = new QVBoxLayout( m_idGroup->layout() );
    m_idGroupLayout->setAlignment( Qt::AlignTop );

    layout3 = new QHBoxLayout( 0, 0, 6, "layout3"); 

    textLabel1_2 = new QLabel( m_idGroup, "textLabel1_2" );
    layout3->addWidget( textLabel1_2 );

    m_masterKeyCombo = new KComboBox( FALSE, m_idGroup, "m_masterKeyCombo" );
    m_masterKeyCombo->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, 1, 0, m_masterKeyCombo->sizePolicy().hasHeightForWidth() ) );
    layout3->addWidget( m_masterKeyCombo );
    m_idGroupLayout->addLayout( layout3 );

    kcfg_GpgRecipient = new KLineEdit( m_idGroup, "kcfg_GpgRecipient" );
    m_idGroupLayout->addWidget( kcfg_GpgRecipient );

    kcfg_GpgRecipientList = new KEditListBox( m_idGroup, "kcfg_GpgRecipientList" );
    kcfg_GpgRecipientList->setCheckable( FALSE );
    kcfg_GpgRecipientList->setButtons( int( KEditListBox::Remove | KEditListBox::Add ) );
    m_idGroupLayout->addWidget( kcfg_GpgRecipientList );

    layout6 = new QHBoxLayout( 0, 0, 6, "layout6"); 

    m_userKeysFound = new KLed( m_idGroup, "m_userKeysFound" );
    m_userKeysFound->setShape( KLed::Circular );
    m_userKeysFound->setLook( KLed::Sunken );
    layout6->addWidget( m_userKeysFound );

    textLabel1 = new QLabel( m_idGroup, "textLabel1" );
    layout6->addWidget( textLabel1 );
    spacer3 = new QSpacerItem( 50, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout6->addItem( spacer3 );
    m_idGroupLayout->addLayout( layout6 );

    layout5 = new QHBoxLayout( 0, 0, 6, "layout5"); 

    m_recoverKeyFound = new KLed( m_idGroup, "m_recoverKeyFound" );
    m_recoverKeyFound->setShape( KLed::Circular );
    m_recoverKeyFound->setLook( KLed::Sunken );
    layout5->addWidget( m_recoverKeyFound );

    textLabel2 = new QLabel( m_idGroup, "textLabel2" );
    layout5->addWidget( textLabel2 );
    spacer6 = new QSpacerItem( 16, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout5->addItem( spacer6 );
    m_idGroupLayout->addLayout( layout5 );

    kcfg_EncryptRecover = new QCheckBox( m_idGroup, "kcfg_EncryptRecover" );
    m_idGroupLayout->addWidget( kcfg_EncryptRecover );
    KSettingsGpgDeclLayout->addWidget( m_idGroup );
    spacer5 = new QSpacerItem( 21, 30, QSizePolicy::Minimum, QSizePolicy::Expanding );
    KSettingsGpgDeclLayout->addItem( spacer5 );
    languageChange();
    resize( QSize(601, 418).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );
}

/*
 *  Destroys the object and frees any allocated resources
 */
KSettingsGpgDecl::~KSettingsGpgDecl()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void KSettingsGpgDecl::languageChange()
{
    setCaption( kmm_i18n( "GPG encryption settings" ) );
    QWhatsThis::add( this, kmm_i18n( "This page allows you to set the parameters for encrypted file storage of your <b>KMyMoney</b> data based on <b>GPG</b>.<p>\n"
"Access to the settings is disabled if <b>GPG</b> could not be detected on your system. In this case, please make sure that <b>GPG</b> is working properly for the current user.<p>\n"
"The <i>additional recovery encryption</i> is only accessible, if the necessary key for <b>kmymoney-recover@users.sourceforge.net</b> with id 0x8AFDDC8E is found in your keyring." ) );
    kcfg_WriteDataEncrypted->setText( kmm_i18n( "Use GPG encryption" ) );
    m_idGroup->setTitle( kmm_i18n( "GPG encryption" ) );
    textLabel1_2->setText( kmm_i18n( "Your key" ) );
    QWhatsThis::add( m_masterKeyCombo, kmm_i18n( "This combo box lists all the secret keys you have in your keyring. Select the one you want to use for encryption when saving to a file." ) );
    kcfg_GpgRecipientList->setTitle( kmm_i18n( "Additonal keys" ) );
    QWhatsThis::add( kcfg_GpgRecipientList, kmm_i18n( "Enter the id of the key you want to use for data encryption. This can either be an e-mail address or the hexadecimal key id. In case of the key id don't forget the leading 0x." ) );
    QWhatsThis::add( m_userKeysFound, kmm_i18n( "This symbol denotes, if the key for the given user id has been found in your keyring. It is green when found, dark otherwise." ) );
    textLabel1->setText( kmm_i18n( "Keys for all of the above user ids found" ) );
    QWhatsThis::add( m_recoverKeyFound, kmm_i18n( "This symbol denotes, if the KMyMoney recovery key has been found in your keyring. It is green when found, dark otherwise." ) );
    textLabel2->setText( kmm_i18n( "Recover Key available in keyring" ) );
    kcfg_EncryptRecover->setText( kmm_i18n( "Also encrypt with KMyMoney's recover key" ) );
    QWhatsThis::add( kcfg_EncryptRecover, kmm_i18n( "You can specify to encrypt the data also with the KMyMoney recover key. Only the core KMyMoney developers are in posession of the respective private key required to read back such encrypted data.<p>\n"
"\n"
"This mechanism is provided for the case that you have lost your key and cannot access your data anymore. With this option activated, the KMyMoney developers can decrypt the data and supply you with it in a readable form. Please be prepared, that you have to answer a few detailed questions about the contents of your data before we will send it out.." ) );
}

#include "ksettingsgpgdecl.moc"
